
// PlayDemo_VCDlg.h : header file
//

#pragma once
#include "afxwin.h"

#include "CLS_DlgVedio.h"
#include "CLS_MyPublic.h"
#include "CLS_DlgDrawPolygon.h"
#include "CLS_DlgEZoom.h"
#include "CLS_TDButton.h"
#include "afxcmn.h"
#include "FECDlg.h"
#include "CLS_CudaCoreApi.h"
#include "./CudaCore/RetValue.h"
#include <list>

using namespace std;
typedef struct __CudaVideoMsgInfo
{
	DecAVInfo tAvInfo;
	DecVideoOtherInfo tAvInfoEx;
}CudaVideoMsgInfo;

typedef struct
{
	unsigned short 		iYear;   				/* Year */
	unsigned short 		iMonth;  				/* Month */
	unsigned short 		iDay;    				/* Day */
	unsigned short 		iHour;   				/* Hour */
	unsigned short 		iMinute; 				/* Minute */
	unsigned short 		iSecond; 				/* Second */
}NVS_FILE_TIME,*PNVS_FILE_TIME;

typedef struct tagDemoUserData
{
	int        uiFrameNo;  
	int        uiTimeStamp;
	int        iUserDataType;
	void*	   pvUserData;
	int        iUserDataSize;
}DemoUserData, *pDemoUserData;

typedef struct
{
	unsigned short		m_usSegmentLength;  /*ʱݳ*/
	int					m_CurrentTime;		/*ǰʱ䣬ʱ*/
}TUserDataTimeSegment;

typedef struct
{
	int 	m_width; 
	int		m_height; 
}TAnalysSize;


typedef struct
{
	unsigned int		uiScene;		//˽Э
	unsigned char		ucType;			//㷨
	unsigned char		ucRule;			//
	unsigned char       ucOsd;          //Ƿʾ
	unsigned char		ucLen;			// TLineInfo
	unsigned char		ucLine_num;		//̬߸
}TRuleData;

typedef struct
{
	short 	m_type;		//0-255ΪƵϽ256-512ΪƵϽ
	short	m_value;	//0-100
}TVcaAVanalys;

#define MAX_TVCAAVANALYS	10
typedef struct
{
	int					iNumOutputs;			// Ŀ
	TVcaAVanalys		m_analysInfo[MAX_TVCAAVANALYS];
}TVcaAVanalysEx;

typedef struct
{
	Tvca_cpcInfo 	m_cpcInfo;		/*ͳƽ*/
	vca_TTargetSet	VCATarget;		/*Ŀλ*/
}Tvca_CpcDate;

#define MAX_ENVIRONMENT_DATA	10
typedef struct 
{
	int m_iType;		 //ͣ0-¶ȡ1-ʪ
	int m_iValue;		 //ֵ
}TEnvironmentData;

typedef struct
{
	int iCount;
	TEnvironmentData 	m_strData[MAX_ENVIRONMENT_DATA];	/**/
}TEnvironment;

typedef struct
{
	int m_iUserSignType;	//ûͣ0-ޱǣ1-صǣ2-ƵǣЧ
	int m_iChn;				//Ƶͨ
	int m_iAudioTagStat;	//0-Ƶ(Ƶ)  1-Ƶ(Ƶʼ)
}TUserSignPara;

typedef struct
{
	unsigned short		x;	//0-10000
	unsigned short		y;	//0-10000
} TPoint;

#define MAX_RULE_LINE_POINT_NUM 8

typedef struct
{
	unsigned char		close;								//Ƿգ1-գ0-
	unsigned char		point_num;							/**/
	TPoint				points[MAX_RULE_LINE_POINT_NUM];	/*Ϣ*/
}TLineInfo;

typedef struct
{
	unsigned short 		m_sSize;			/*ṹTTargetAttrĴС*/
	unsigned short		m_sTarget_num;		/*Ŀ<=MAX_SAVE_TARGET_NUM */
}TTargetAttr;

//ڱΪĿԣʽ
typedef struct
{
	TTargetAttr			m_stTgtAttr;		/*Ŀ*/
} TUserDataVcaAttr;

//ṹTTargetAttrInfoаꡢٶȡȣ
typedef struct
{
	unsigned short 		m_sSize;			/*ṹTTargetAttrInfoĴС*/
	unsigned short		m_sId;				/*ĿID*/
	unsigned short		m_sAttrNum;			/*ĿԸ*/
	unsigned short		m_sAttrNumEx;		/* TTargetAttrParaEx ĿԸ*/
}TTargetAttrInfo;

typedef struct
{
	unsigned short 		m_sSize;			/*ṹTTargetAttrInfoĴС*/
	unsigned short		m_sId;				/*ĿID*/
	unsigned short		m_sAttrNum;			/*ĿԸ*/
}TTargetAttrInfoV1;

//ĿԽṹTTargetAttrParaд洢ĿԣעеĹ
typedef struct
{
	int				m_iAttrPara;	/*Ŀ
									m_iAttrPara [31-24bit]ʾ
									m_iAttrPara [23-0bit]ʾֵ
									֧256,*/
}TTargetAttrPara;

//ĿԽṹTTargetAttrParaExд洢䳤ĿԣעеĹ
typedef struct
{
	unsigned short		m_iType;    		//
	unsigned short		m_iLength;  		// m_iAttrPara[0]Գȣע4ֽڶ
	char				m_cAttrPara;		/*Ŀݡ*/

}TTargetAttrParaEx;

typedef struct
{
	unsigned short	 m_size;
	unsigned short	 m_AddPass;
}Tvca_cpcInfoV1;

typedef struct
{
	unsigned short   m_size;
	unsigned short   m_value;		//λʾЧͣbit0-inbit1-outbit2-pass
	unsigned short   m_countIn;
	unsigned short   m_countOut;
	unsigned short	 m_countPass;
}Tvca_cpcInfoV3;

typedef struct
{
	int   x;						//ƥ꣬ʮֱ
	int   y;						//ƥ꣬ʮֱ
	unsigned int		time;		//ƥʱλms
}UserDataTWSPointInfo;


//ˮ߻Ϣ
typedef struct
{
	unsigned short		size;
	unsigned short		lineLength;			//̶߳ȣֱȣ
	unsigned short		lineWidth;			//̶߿ȣֱȣ
	unsigned short		relativeUnit;		//Կ̶ȵλ 0-m1-dm2-cm3-mm
	unsigned short		absoluteUnit;		//Կ̶ȵλ 0-m1-dm2-cm3-mm
	unsigned short		x;					//ˮߺλãֱȣ
	unsigned short		y;					//Կ̶ֱ꣨ȣ
	unsigned short		relativeNum;		//Կ̶ȵ
	float				absolute;			//Կ̶ֵ
	unsigned int		color;				//ˮɫ rgb
}TGaugeBase;

//ˮ߿̶Ϣ
typedef struct
{
	unsigned short		size;
	unsigned short		y;				//ˮֱ꣨ȣ
	float				high;			//ˮԿ̶
}TGaugePoint;

typedef struct
{
	TGaugeBase		base;
	TGaugePoint		gauge;
}TUserData_Gauge;

#define MAX_AREA_NUM_EX  12				   //
#define MAX_ILLEGAL_PARKING_POINTNUM  16   //
typedef struct
{
	unsigned short m_usX;
	unsigned short m_usY;
}TIllegalPark_POINT;

typedef struct
{
	unsigned short		m_usRIllegalParkNo;				 // 0ʼ
	unsigned short		m_usIllegalParkAreaCounts;       //Υͣ
	TIllegalPark_POINT  m_structAreaEx[MAX_ILLEGAL_PARKING_POINTNUM];	//Υͣ
}TIllegalParkInfo;

// CPlayDemo_VCDlg dialog
class CPlayDemo_VCDlg : public CDialog
{
public:
	CPlayDemo_VCDlg(CWnd* pParent = NULL);	// standard constructor
	enum { IDD = IDD_PLAYDEMO_VC_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	HICON m_hIcon;
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
private:
	SDK_VERSION    m_Version;
	CString        m_cstrVersionString;
	int            m_iSpeed[MAX_WINDOWNUM];
	bool		   m_bLeftMouseDown;
	bool		   m_bTotalTimeFocus;
public:
	bool			m_blStatus;
	int             m_iEZoomID;
	CLS_DlgVedio *m_pDlgVedio[MAX_WINDOWNUM];
	CLS_PlaySDK   m_PlaySDK;
	CLS_DlgDrawPolygon m_DlgDrawPolygon;
	CLS_DlgEZoom m_DlgEZoom;
	CLS_FECDlg m_FECDlg;
	void Init();
	void DisplayFrame();
	void ShutWindow();
	bool IsPlayOnCurWin(int _iWinNum);
	CStatic m_gpVedio;
	int m_iCurVedio_Count;//Ϊл1.4.9.16ڵı
	int m_iCurWinNum;	  //-----ǰѡеĲŴڵţ0-15
	int m_iWidth;
	int m_iHeight;
	CMenu   m_mnPopMenu;      //Ҽ˵
	CLS_TDButton m_btnOpenFile;
	FILE *m_fpSave;
	bool m_bGetIFrame;
	int m_iSputRetValue[MAX_WINDOWNUM + MAX_SPECIAL_PLAYER_NUM];
	std::map<int, CString>   m_mapInfo;
	char* m_cFileDataBuf[MAX_WINDOWNUM + MAX_SPECIAL_PLAYER_NUM];
	int m_iAudio[MAX_WINDOWNUM];			//¼Ƶ״̬
	int m_iBmpNum;                          //ץBmpͼƬеֵ 
	afx_msg void OnBnClickedBtn1();
	afx_msg void OnBnClickedBtn4();
	afx_msg void OnBnClickedBtn9();
	afx_msg void OnBnClickedBtn16();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnClose();
	afx_msg void OnBnClickedBtnOpenFile();
    void openFileFFmpegSoftDecode(CString& cstrPath);
    void openFile(CString& cstrPath);
	afx_msg void OnBnClickedBtnOpenStream();
	afx_msg void OnBnClickedBtnClose();
	afx_msg void OnBnClickedBtnSet();
	afx_msg LRESULT OnEventMessage(WPARAM wParam, LPARAM lParam);
	void GetData(int _iID);
	void ChangePutSpeed(int _iSpeedType);
	int PsPack_StopRecord();
	int PsPack_StartRecord();
	int PsPack_InputData(unsigned char* _ucData, int _iSize, int _iType);
	static int __cdecl PsPackNotify(int _iPlayerID, unsigned char* _ucData, int _iSize, PSPACK_INFO* _pPsPackInfo, void* _pContext);
	static void __cdecl PlayEndFun(int _iID);
	static int __cdecl CommonEventNotify(int _iPlayerID, int _iEventMessage, void* _lpUserData);
	static void  __cdecl GetDecAVCbk(int _iID, const DecAVInfo *_pDecAVInfo);
	static void __cdecl OutPutAudio(unsigned char* _pucData, int _iLen, void* _pvUserData);
	static void __cdecl ShowMotionArea(long _iPlayFd, HDC _hDc, int _iUsr);	
protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
public:
	virtual void WinHelp(DWORD dwData, UINT nCmd = HELP_CONTEXT);
	void OnBnClickedBtnOpenAll();
	CButton m_btnAudio;
	int m_iEditFrame;

//ؼ
	CButton		m_chkSync;

	CProgressCtrl m_prgPlay;
	CSliderCtrl m_sld_progress;
	afx_msg void OnBnClickedBtnCaptureyuv();
	afx_msg void OnBnClickedBtnCapturebmp();
	afx_msg void OnBnClickedBtnPlay();
	afx_msg void OnBnClickedBtnPause();
	afx_msg void OnBnClickedBtnStep();
	afx_msg void OnBnClickedBtnBackstep();
	afx_msg void OnBnClickedBtnHome();
	afx_msg void OnBnClickedBtnEnd();
	afx_msg void OnBnClickedBtnFast();
	afx_msg void OnBnClickedBtnSlow();
	afx_msg void OnBnClickedBtnSearch();
	afx_msg void OnBnClickedBtnAudio();
	afx_msg void OnBnClickedBtnSeek();
	afx_msg void OnNMCustomdrawSldProgress(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedBtnPlayVod();
	afx_msg void OnBnClickedBtnCleanBuffer();
	afx_msg void OnDeltaposSpinSpeed(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	unsigned int  m_uiTimerGetPlayTime;
	unsigned int  m_uiTimerInputStream;
	unsigned int  m_uiTimerMain;
	unsigned int  m_uiTimerBatchCudaTest;
	unsigned int  m_uiTimerBatchCaptureTest;
	CEdit m_edtMsg;
	int m_edtCurSpeed;
	int m_iCurPlayNum;
	int m_iEdtTotalTime;
	int m_iEdtVSync;
	CButton m_btnCaptureAudio;
	CSpinButtonCtrl m_SpinAudio;
	int m_iEdtAudio;
	afx_msg void OnBnClickedBtnGetdecdata();
	afx_msg void OnBnClickedBtnStopGetdecdata();
	afx_msg void OnEnSetfocusDectotaltime();
	afx_msg void OnEnKillfocusDectotaltime();
	afx_msg void OnBnClickedBtnVsync();
	afx_msg void OnBnClickedBtnRecord();
	afx_msg void OnBnClickedBtnStoprec();
	afx_msg void OnBnClickedBtnFindvca();
	afx_msg void OnBnClickedBtnCaptureaudio();
	afx_msg void OnBnClickedCheckDrawmotionarea();
	afx_msg void OnBnClickedBtnDrawpolygon();
	void UpdateUI_ShowAudioVolume(const int _iPlayerID);
	afx_msg void OnBnClickedBtnSetezoom();
	afx_msg void OnDeltaposSpinAudio(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedButtonSetFec();
	afx_msg void OnBnClickedBtnReverse();
	afx_msg void OnBnClickedBtnOpenStreamCuda();
	afx_msg void OnBnClickedChkCudaTest();
	void CudaFilePlayerTest();
	void StartPlayFileNormal(int _iPlayWindowIndex, CString _cstrFileName);
	void EnableWindowNumSelect(bool _blEnable);
	void StartPlayFileWithCuda(int _iPlayWindowIndex, CString _cstrFileName);
	void StopPlayFile(int _iPlayWindowIndex);
	void StopPlaySpecial(int _iSpecialPlayIndex);
	void StartBatchCudaTest();
	void StopBatchCudaTest();
	void OnTimerBatchCudaTest();
	void OnTimerBatchCaptureBmp();
	void CaptureBmp(int _iPlayWindowIndex);
	void StartPlayGetNotifyDataWithCuda(int _iPlayWindowIndex, CString _cstrFileName);
	void Notify_DecodeAudioVideo(int _iPlayerId, DecAVInfo* _pAVInfo);
	afx_msg void OnBnClickedBtnStartDrawrect();
	afx_msg void OnBnClickedBtnStopDrawrect();
private:
	
	CButton m_chkDxvaHardDecode;
	CButton m_chkPrivateSoftDecode;
	CButton m_chkFfmpegSoftDecode;
	CButton m_chkVideoRenderD3D;
	CButton m_chkVideoRenderDraw;
	CButton m_chkVideoDispalyYuv422;
	CButton m_chkVideoDispalyYuv420;
public:
	afx_msg void OnBnClickedCheckDxvaHw();
	afx_msg void OnBnClickedCheckPrivateDecoder();
	afx_msg void OnBnClickedCheckFfmpegDecoder();
	afx_msg void OnBnClickedCheckVideoRenderD3d();
	afx_msg void OnBnClickedCheckVideoRenderDraw();
	afx_msg void OnBnClickedCheckVideoDisplay422();
	afx_msg void OnBnClickedCheckVideoDisplay420();
	afx_msg void OnBnClickedCheckSync();
	afx_msg void OnBnClickedBtnReverseStep();
private:
    list <DemoUserData*> m_lstUsrData;
	CRITICAL_SECTION m_tLockLst;
	CButton m_chkUniversalPlayer;
	CButton m_chkSaveUserData;
	FILE* m_pfSaveUserDataFile;
	HANDLE m_hThreadHdl;
	int m_bIsUsrDataEnd;
public:
	afx_msg void OnBnClickedCheckSaveUserData();
	static void __stdcall DevUserDataNotify(unsigned int _uiID, int _iType, void* _pvData, int _iDataLen, CurrentFrameInfo* _ptInfo, void* _pvUdata);
	static unsigned int WINAPI SaveUserDataThread(LPVOID _Param);
	void SaveUserDataToLocalFile(DemoUserData*);
	CComboBox m_cboRecFileType;
	int seconds_to_file_time(NVS_FILE_TIME* filetime, long seconds);
};

