﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace CSharpPlayerDemo
{
    //速度控制类型
    enum eSpeedType
    {
        SPEED_DEC = 0,
        SPEED_ADD,
        SPEED_SET
    }

    //矩形结构
    [StructLayout(LayoutKind.Sequential)]
    public struct RECT
    {
        public Int32 left;
        public Int32 top;
        public Int32 right;
        public Int32 bottom;
    }

    //版本信息结构
    [StructLayout(LayoutKind.Sequential)]
    public struct SDK_VERSION
    {
        public UInt16 m_ulMajorVersion;
        public UInt16 m_ulMinorVersion;
        public UInt16 m_ulBuider;
        public String m_cVerInfo;
    }

    //文件播放完毕事件委托
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]//C接口声明
    public delegate void delegatePlayEndFun(int _iID);   
}
